/* ************************************************************************

   Copyright: Weizmann Institute of Science

   License: GPL

   Authors: Evgeny Stambulchik

************************************************************************ */

/* ************************************************************************


#asset(pf/image/*)

************************************************************************ */


function changeN_e(ev)
{
    var e = ev.getTarget();
    var N_e = e.getNumValue();
    
    if (isFinite(N_e) && this.e.setN(N_e)) {
        this.updatePlasmaParameters();
        this.updateGUI();
    }
}

function changeT_e(ev)
{
    var e = ev.getTarget();
    var T_e = e.getNumValue();
    
    if (isFinite(T_e)) {
        this.e.setT(T_e);
        this.i.setT(T_e);
        this.r.setT(T_e);
        this.updateGUI();
    }
}

function changeZ_i(ev)
{
    var e = ev.getTarget();
    var Z_i = parseInt(e.getValue());
    
    if (isFinite(Z_i)) {
        this.i.setQ(Z_i);
        this.updatePlasmaParameters();
        this.updateGUI();
    }
}

function changeT_i(ev)
{
    var e = ev.getTarget();
    var T_i = e.getNumValue();
    
    if (isFinite(T_i)) {
        this.i.setT(T_i);
        this.r.setT(T_i);
        this.updateGUI();
    }
}

function changeZ_r(ev)
{
    var e = ev.getTarget();
    var Z_r = parseInt(e.getValue());
    
    if (isFinite(Z_r)) {
        this.r.setQ(Z_r);
        this.updatePlasmaParameters();
        this.updateGUI();
    }
}

function changeP_r(ev)
{
    var e = ev.getTarget();
    var P_r = parseInt(e.getValue())/100.0;
    
    if (isFinite(P_r)) {
        this.P_r = P_r;
        this.updatePlasmaParameters();
        this.updateGUI();
    }
}

function changeT_r(ev)
{
    var e = ev.getTarget();
    var T_r = e.getNumValue();
    
    if (isFinite(T_r)) {
        this.r.setT(T_r);
        this.updateGUI();
    }
}

function changeM_i(ev)
{
    var e = ev.getTarget();
    var M_i = parseInt(e.getValue());
    
    if (isFinite(M_i)) {
        this.i.setM(M_i);
        this.updateGUI();
    }
}

function changeM_r(ev)
{
    var e = ev.getTarget();
    var M_r = parseInt(e.getValue());
    
    if (isFinite(M_r)) {
        this.r.setM(M_r);
        this.updateGUI();
    }
}

function changeN_u(ev)
{
    var e = ev.getTarget();
    var n_u = parseInt(e.getValue());
    
    this.n_u = n_u;
    this.updateGUI();
}

function changeN_l(ev)
{
    var e = ev.getTarget();
    var n_l = parseInt(e.getValue());
    
    this.n_l = n_l;
    this.updateGUI();
}

function changeB(ev)
{
    var e = ev.getTarget();
    var v = e.getNumValue();
    
    if (isFinite(v)) {
        this.B = v;
        this.updateGUI();
    }
}

function viewMenuCB(ev)
{
    var explorer_is_seen;
    
    if (this.entity_tree.isSeeable()) {
        explorer_is_seen = true;
    } else {
        explorer_is_seen = false;
    }
    
    this.showSectionsButton.setEnabled(explorer_is_seen);
    this.showSpeciesButton.setEnabled(explorer_is_seen);
    this.redrawButton.setEnabled(this.canvas.isSeeable());

    if (this.prefs.autoLoadWiki) {
        this.loadWikiButton.setEnabled(false);
    } else {
        var tree = this.entity_tree;
        var leaf = tree.getSelectedElement();
        if (leaf && leaf.classname == "qx.legacy.ui.tree.TreeFile" && explorer_is_seen) {
            this.loadWikiButton.setEnabled(true);
        } else {
            this.loadWikiButton.setEnabled(false);
        }
    }
}

function editMenuCB(ev)
{
    var explorer_is_seen;
    
    if (this.entity_tree.isSeeable()) {
        explorer_is_seen = true;
    } else {
        explorer_is_seen = false;
    }

    var tree = this.entity_tree;
    var leaf = tree.getSelectedElement();

    if (leaf && leaf.classname == "qx.legacy.ui.tree.TreeFile" && explorer_is_seen) {
        if (this.isFavorite(leaf)) {
            this.editMenuButtonAddToFav.setEnabled(false);
            this.editMenuButtonRemFromFav.setEnabled(true);
        } else {
            this.editMenuButtonAddToFav.setEnabled(true);
            this.editMenuButtonRemFromFav.setEnabled(false);
        }
    } else {
        this.editMenuButtonAddToFav.setEnabled(false);
        this.editMenuButtonRemFromFav.setEnabled(false);
    }
}

function treeMenuCB(ev)
{
    if (ev.getButton() == "right") {
        var menu = this.treeMenu;

        if (menu.isSeeable()) {
            menu.hide();
        } else {
            var leaf = ev.getTarget();
            var el = leaf.getElement();
            
            if (leaf.classname == "qx.legacy.ui.tree.TreeFile") {
                if (this.isFavorite(leaf)) {
                    this.treeMenuButtonAddToFav.setEnabled(false);
                    this.treeMenuButtonRemFromFav.setEnabled(true);
                } else {
                    this.treeMenuButtonAddToFav.setEnabled(true);
                    this.treeMenuButtonRemFromFav.setEnabled(false);
                }
            } else {
                this.treeMenuButtonAddToFav.setEnabled(false);
                this.treeMenuButtonRemFromFav.setEnabled(false);
            }
            
            // position the menu
            menu.setLeft(ev.getClientX());
            menu.setTop(ev.getClientY());

            menu.show();
        };

        ev.stopPropagation();
    }
}

function showFundamentalCB(ev)
{
    this.showFundamental = !this.showFundamental;
    this.rePopulateTree();
}

function showSpectroscopyCB(ev)
{
    this.showSpectroscopy = !this.showSpectroscopy;
    this.rePopulateTree();
}

function showWavesCB(ev)
{
    this.showWaves = !this.showWaves;
    this.rePopulateTree();
}

function showCollisionsCB(ev)
{
    this.showCollisions = !this.showCollisions;
    this.rePopulateTree();
}

function showElectronsCB(ev)
{
    this.showElectrons = !this.showElectrons;
    this.rePopulateTree();
}

function showIonsCB(ev)
{
    this.showIons = !this.showIons;
    this.rePopulateTree();
}

function showRadiatorsCB(ev)
{
    this.showRadiators = !this.showRadiators;
    this.rePopulateTree();
}

function addToFavCB(ev)
{
    var tree = this.entity_tree;
    var leaf = tree.getSelectedElement();

    if (!leaf) {
        return;
    }

    leaf.setTextColor("red");

    // Add to the list of favorites
    var fav = new Array;
    fav.entity  = leaf.getUserData("entity");
    fav.species = leaf.getUserData("species");
    fav.color   = this.nextColor();
    this.favorites.push(fav);
    
    // Switch the dimension selector ...
    this.gui_compare_dim.selectByValue(fav.entity.dimension);
    // ... and update the list of favorites
    this.updateFavoritesListView();
    this.updateLegendListView();
}

function removeFromFavCB(ev)
{
    var tree = this.entity_tree;
    var leaf = tree.getSelectedElement();

    if (!leaf) {
        return;
    }
    leaf.setTextColor("black");

    var entity  = leaf.getUserData("entity");
    var species = leaf.getUserData("species");

    // Remove from the list of favorites
    for (var k = 0; k < this.favorites.length; k++) {
        var fav = this.favorites[k];
        if (fav.entity  == entity && fav.species == species) {
            this.favorites.splice(k, 1);
            break;
        }
    }

    // Switch the dimension selector ...
    this.gui_compare_dim.selectByValue(entity.dimension);
    // ... and update the list of favorites
    this.updateFavoritesListView();
    this.updateLegendListView();
}

function clickTreeCB(ev)
{
    var e = ev.getTarget();
    if (e.isSelected()) {
        var entity = e.getUserData("entity");

        if (entity) {
            this.gui_entity_units.update(entity.dimension,
                this.prefs.units[entity.dimension]);
        } else {
            this.gui_entity_units.update(null, null);
        }
        
        this.updateEntityValue();
    }
}

function changeUnitsCB(ev)
{
    this.updateEntityValue();
}

/**
 * The application
 */
qx.Class.define("pf.Application",
{
    extend : qx.application.Inline,
    include : [qx.legacy.application.MGuiCompat],

    /*
    *****************************************************************************
       MEMBERS
    *****************************************************************************
    */

    members :
    {
        R0 : 0.5, // 0.3/0.7/1 ?
        
        showFundamental  : true,
        showSpectroscopy : true,
        showWaves        : true,
        showCollisions   : true,

        showElectrons  : true,
        showIons       : true,
        showRadiators  : true,

        checkPlasmaParameters : function()
        {
            if ((this.P_r < 0.0 || this.P_r > 1.0) ||
                this.i.getQ() < 1 ||
                this.P_r == 1.0 && this.r.getQ() == 0) {
                return false;
            } else {
                return true;
            }
        },

        updatePlasmaParameters : function()
        {
            // Safety measures
            if (this.checkPlasmaParameters() != true) {
                return false;
            }
            
            var N_e = this.e.getN();
            var N_i, N_r;
            
            if (this.P_r < 1.0) {
                N_i = N_e*(1.0 - this.P_r)/
                    (this.i.getQ()*(1.0 - this.P_r) + this.r.getQ()*this.P_r);
                
                N_r = N_i*this.P_r/(1.0 - this.P_r);
            } else {
                N_i = 0.0;
                N_r = N_e/this.r.getQ();
            }
            
            this.i.setN(N_i);
            this.r.setN(N_r);
            
            return true;
        },
        
        updateGUI : function()
        {
            this.gui_N_e.setNumValue(this.e.getN());
            this.gui_T_e.setNumValue(this.e.getT());
            
            this.gui_N_i.setNumValue(this.i.getN());
            this.gui_T_i.setNumValue(this.i.getT());
            this.gui_Z_i.setValue(this.i.getQ());
            this.gui_M_i.setValue(this.i.getM());

            this.gui_N_r.setNumValue(this.r.getN());
            this.gui_T_r.setNumValue(this.r.getT());
            this.gui_Z_r.setValue(this.r.getQ());
            this.gui_Zcore.setValue(this.r.getQ() + 1);
            this.gui_M_r.setValue(this.r.getM());
            
            this.gui_B.setNumValue(this.B);
            
            this.gui_n_u.setValue(this.n_u);
            this.gui_n_l.setValue(this.n_l);
            
            // Update the currently selected entity
            this.updateEntityValue();
            
            // Update the list of favorites
            this.updateFavoritesListView();
            this.updateLegendListView();
        },
        
        getWavenumber : function()
        {
            var n_u = this.n_u;
            var n_l = this.n_l;
            var Z_core = this.r.getQ() + 1;
            
            return pf.base.Bohr.transitionEnergy(Z_core, n_u, n_l);
        },
        
        getMinEnergyDistance : function()
        {
            var n;
            if (this.n_u < this.n_l) {
                n = this.n_l;
            } else {
                n = this.n_u;
            }
            
            var Z_core = this.r.getQ() + 1;
            
            return pf.base.Bohr.transitionEnergy(Z_core, n + 1, n);
        },
        
        getNaturalWidth : function()
        {
            var n_u = this.n_u;
            var n_l = this.n_l;
            var Z_core = this.r.getQ() + 1;
            
            return Math.pow(Z_core, 4)*
                (pf.base.Bohr.LymanA(n_u) + pf.base.Bohr.LymanA(n_l))/3e10/(2*Math.PI);
        },
        
        getDopplerHwhm : function()
        {
            var v   = this.r.getThermalVelocity();
            var nu  = this.getWavenumber();
            
            return Math.sqrt(2*Math.log(2))*nu*v/3e10;
        },
        
        getMicrofieldFrequency : function(s)
        {
            var r = s.getMeanDistance();
            var v_r = this.r.getThermalVelocity();
            var v_s = s.getThermalVelocity();
            var v = Math.sqrt(v_r*v_r + v_s*v_s);
            
            return v/r;
        },
        
        getFullDebyeLength : function(s)
        {
            var tmp = 0;
            var m = s.getM();
            
            var sa = new Array(this.e, this.i, this.r);
            for (var i = 0; i < 3; i++) {
                var os = sa[i];
                if (os.getM() <= m) {
                    var ld = os.getDebyeLength();
                    if (ld) {
                        tmp += 1/(ld*ld);
                    }
                }
                
            }
            
            return 1/Math.sqrt(tmp);
        },
        
        getPpiFactor : function(s)
        {
            var dl = this.getFullDebyeLength(s);
            var r1 = s.getMeanDistance();
            var r;
            if (isFinite(dl) && isFinite(r1)) {
                r = r1/dl;
            } else {
                r = 0;
            }
            
            return (1 + r)*Math.exp(-r);
            // return 1 - 0.6*r
        },
        
        getRpiFactor : function(s)
        {
            var r1 = s.getMeanDistance();
            var q_r = this.r.getQ();
            var q_s = s.getQ();
            if (q_r == 0 || q_s == 0) {
                return 1;
            }
             
            var r_m = s.getMinApproachDistance()*q_r/q_s;
            return Math.exp(-r_m/r1);
        },
        
        getQsHwhm : function(s)
        {
            var n_u = this.n_u;
            var n_l = this.n_l;
            var Z_core = this.r.getQ() + 1;
            var ef = s.getHoltsmarkField();
            var ppi = this.getPpiFactor(s);
            var rpi = this.getRpiFactor(s);
            
            // 1.4385 is S_1 HWHM
            var hwhm = 1.4385*4.271417e-5*3/2*(n_u*n_u - n_l*n_l)/Z_core*ef*ppi*rpi;
            
            // rude correction for alpha lines
            if (n_u - n_l == 1) {
                hwhm /= 2;
            }
            
            return hwhm;
        },
        
        getDynHwhm : function(s)
        {
            // neglect dynamic PP effects
            var ppi = 1.0;
            // assume dynamic RP effect == static one
            var rpi = this.getRpiFactor(s);

            var fwhm = this.getMicrofieldFrequency(s)/3e10/(2*Math.PI)*ppi*rpi;
            
            return fwhm/2;
        },
        
        getStarkRatio : function(s)
        {
            var R;
            var w_qs = this.getQsHwhm(s);
            if (w_qs == 0) {
                R = 0;
            } else {
                var w_dyn = this.getDynHwhm(s);
                R = w_qs/w_dyn;
            }
            
            return R;
        },
        
        getStarkQuasistaticity : function(s)
        {
            var R = this.getStarkRatio(s);
            return R/(R + this.R0);
        },
        
        getStarkHwhm : function()
        {
            var w = 0;
            
            var sa = new Array(this.e, this.i, this.r);
            for (var i = 0; i < 3; i++) {
                var s = sa[i];
                var qs = this.getQsHwhm(s);
                var f  = this.getStarkQuasistaticity(s);

                w += Math.pow(f*qs, 3/2);
            }
            
            return Math.pow(w, 2/3);
        },
        
        getZeemanSplitting : function()
        {
            return 0.466860*this.B;
        },

        getTotalFwhm : function()
        {
            var s_hwhm = this.getStarkHwhm();
            var z_hwhm = this.getZeemanSplitting();
            var d_hwhm = this.getDopplerHwhm();
            return 2*Math.sqrt(s_hwhm*s_hwhm + z_hwhm*z_hwhm + d_hwhm*d_hwhm);
        },
        
        getBremsstrahlungLosses : function()
        {
            var z_i = this.i.getQ();
            var z_r = this.r.getQ();
            return 1.69e-32*this.e.getN()*Math.sqrt(this.e.getT())*
                (this.i.getN()*z_i*z_i + this.r.getN()*z_r*z_r);
        },
        
        getBremsstrahlungSpectralDensity : function()
        {
            var photon_eV = this.getWavenumber()/8065.5;
            return this.getBremsstrahlungLosses()/(8065.5*this.e.getT())*
                Math.exp(-photon_eV/this.e.getT());
        },
        
        getFreeBoundLosses : function()
        {
            var z_i = this.i.getQ();
            var z_r = this.r.getQ();
            return -1.69e-32/8065.5*this.e.getN()/Math.sqrt(this.e.getT())*
                (this.i.getN()*z_i*z_i*pf.base.Bohr.bindingEnergy(z_i, 1) +
                 this.r.getN()*z_r*z_r*pf.base.Bohr.bindingEnergy(z_r, 1));
        },
        
        getFreeBoundSpectralDensity : function()
        {
            var photon_eV = this.getWavenumber()/8065.5;
            return this.getFreeBoundLosses()/(8065.5*this.e.getT())*
                Math.exp(-photon_eV/this.e.getT());
        },
        
        getBoundBoundLosses : function()
        {
            var Z_core = this.r.getQ() + 1;
            var photon_eV =
                pf.base.Bohr.transitionEnergy(Z_core, 2, 1)/8065.5;
            
            // FIXME!!
            var level_pop = Math.exp(-photon_eV/this.e.getT());
            
            return level_pop*Math.pow(Z_core, 4)*pf.base.Bohr.LymanA(2)*
                1.6022e-19*photon_eV*this.r.getN();
        },
        
        getPressure : function()
        {
            return this.e.getPressure() +
                   this.i.getPressure() +
                   this.r.getPressure();
        },
        
        getMagneticFieldPressure : function()
        {
            return 3.98e6*this.B*this.B;
        },
        
        getBeta : function()
        {
            return this.getPressure()/this.getMagneticFieldPressure();
        },
        
        getFermiEnergy : function()
        {
            return 2.94128e-11*Math.pow(this.e.getN(), 2/3);
        },
        
        getAlfvenVelocity : function()
        {
            var v_m1;
            
            v_m1 = 1/this.e.getAlfvenVelocity(this.B) +
                   1/this.i.getAlfvenVelocity(this.B);
        
            if (this.r.getQ() != 0) {
                v_m1 += 1/this.r.getAlfvenVelocity(this.B);
            }
            
            return 1/v_m1;
        },
        

        getEntityFullName : function (entity, species)
        {
            var name = entity.name;
            if (entity.nspecies == 1) {
                var prepos = entity.prepos;
                if (!prepos) {
                    prepos = "of";
                }
                name += " " + prepos + " ";
                switch (species.id) {
                case "e":
                    name += "electrons";
                    break;
                case "i":
                    name += "ions";
                    break;
                case "r":
                    name += "radiators";
                    break;
                }
            }
            
            return name;
        },
        
        evaluateEntityValue : function(entity, species)
        {
            var formula;
            if (entity.nspecies == 1) {
                var species_str = "this." + species.id;
                formula = entity.formula.replace(/\%s1/g, species_str);
            } else {
                formula = entity.formula;
            }
            var v = eval(formula);
            
            return v;
        },
        
        updateEntityValue : function()
        {
            var tree = this.entity_tree;
            var leaf = tree.getSelectedElement();
            
            if (!leaf) {
                return;
            }
            
            var entity  = leaf.getUserData("entity");
            var species = leaf.getUserData("species");
            
            var name, section, value;
            if (entity) {
                var v     = this.evaluateEntityValue(entity, species);
                var scale = this.gui_entity_units.getSelected().getValue();
                
                name    = this.getEntityFullName(entity, species);
                section = entity.section;
                value   = v*scale
            } else {
                name    = null;
                section = null;
                value   = 0;
            }
            
            this.gui_entity_name.setValue(name);

            this.gui_entity_section.setValue(section);

            this.gui_entity_value.setNumValue(value);
            
            if (this.prefs.autoLoadWiki) {
                this.showWikiPage(entity);
            } else {
                this.gui_wiki.setSource(null);
            }
        },

        isFavorite : function(leaf)
        {
            var entity  = leaf.getUserData("entity");
            var species = leaf.getUserData("species");

            for (var k = 0; k < this.favorites.length; k++) {
                var fav = this.favorites[k];
                if (fav.entity  == entity && fav.species == species) {
                    return true;
                    break;
                }
            }
            
            return false;
        },

        populateTree : function()
        {
            var i, n = plasma_entities.length;
            var sa = new Array;
            if (this.showElectrons) {
                sa.push(this.e)
            }
            if (this.showIons) {
                sa.push(this.i)
            }
            if (this.showRadiators) {
                sa.push(this.r)
            }
            
            for (var i = 0; i < n; i++) {
                var entity = plasma_entities[i];
                
                if (entity.section == "fundamental" &&
                    this.showFundamental != true) {
                    continue;
                }
                if (entity.section == "spectroscopy" &&
                    this.showSpectroscopy != true) {
                    continue;
                }
                if (entity.section == "waves" &&
                    this.showWaves != true) {
                    continue;
                }
                if (entity.section == "collisions" &&
                    this.showCollisions != true) {
                    continue;
                }
                
                var folder;
                switch (entity.dimension) {
                case "frequency":
                    folder = this.gui_folder_freq;
                    break;
                case "length":
                    folder = this.gui_folder_length;
                    break;
                case "velocity":
                    folder = this.gui_folder_vel;
                    break;
                case "energy":
                    folder = this.gui_folder_energy;
                    break;
                case "pressure":
                    folder = this.gui_folder_pressure;
                    break;
                case "area":
                    folder = this.gui_folder_area;
                    break;
                case "power_density":
                    folder = this.gui_folder_power_density;
                    break;
                case "spectral_power_density":
                    folder = this.gui_folder_spectral_power_density;
                    break;
                case "none":
                    folder = this.gui_folder_none;
                    break;
                default:
                    folder = this.gui_folder_misc;
                    break;
                }
                
                var leaf;
                
                switch (entity.nspecies) {
                case 1:
                    for (var j = 0; j < sa.length; j++) {
                        var s = sa[j];
                        var icon = "pf/image/" + s.id + "_small.png";

                        leaf = new qx.legacy.ui.tree.TreeFile(entity.name, icon);
                        leaf.addListener("changeSelected", clickTreeCB, this);
                        leaf.addListener("contextmenu", treeMenuCB, this);
                        leaf.setUserData("entity", entity);
                        leaf.setUserData("species", s);
                        
                        if (this.isFavorite(leaf)) {
                            leaf.setTextColor("red");
                        }

                        folder.add(leaf);
                    }
                    break;
                default:
                    leaf = new qx.legacy.ui.tree.TreeFile(entity.name,
                        "pf/image/all_small.png");
                    leaf.addListener("changeSelected", clickTreeCB, this);
                    leaf.addListener("contextmenu", treeMenuCB, this);
                    leaf.setUserData("entity", entity);

                    if (this.isFavorite(leaf)) {
                        leaf.setTextColor("red");
                    }
                    
                    folder.add(leaf);
                    break;
                }
            }
        }, 

        cleanTree : function()
        {
            this.gui_folder_freq.removeAll();
            
            this.gui_folder_length.removeAll();
            
            this.gui_folder_vel.removeAll();
            
            this.gui_folder_none.removeAll();
            
            this.gui_folder_energy.removeAll();
            
            this.gui_folder_pressure.removeAll();
            
            this.gui_folder_area.removeAll();
            
            this.gui_folder_power_density.removeAll();

            this.gui_folder_spectral_power_density.removeAll();
            
            this.gui_folder_misc.removeAll();
        },

        rePopulateTree : function()
        {
            this.cleanTree();
            
            this.populateTree();
        },


        updateFavoritesListView : function()
        {
            var lv = this.favoritesListView;
            var rowData = lv.getData();
            rowData.length = 0;
            
            var dimension = this.gui_compare_dim.getSelectedValue();
            
            var scale = this.gui_compare_units.getSelectedValue();
            
            for (var i = 0; i < this.favorites.length; i++) {
                var fav = this.favorites[i];
                var entity = fav.entity;
                
                if (entity.dimension != dimension) {
                    continue;
                }
                
                var species = fav.species;

                var icon;
                if (species) {
                    icon = "pf/image/" + species.id + "_small.png";
                } else {
                    icon = "pf/image/all_small.png";
                }
                var name = this.getEntityFullName(entity, species);
                var value = scale*this.evaluateEntityValue(entity, species);

                rowData.push({ s_icon  : {icon       : icon,
                                          iconWidth  : 16, 
                                          iconHeight : 16             },
                               name    : {text       : name           },
                               section : {text       : entity.section },
                               value   : {text       : pf.util.Format.numPrint(value)}
                             });
            }
            
            lv.updateSort();
            lv.update();
        },

        updateLegendListView : function()
        {
            var lv = this.legendListView;
            var rowData = lv.getData();
            rowData.length = 0;
            
            var dimension = this.gui_compare_dim.getSelectedValue();
            
            for (var i = 0; i < this.favorites.length; i++) {
                var fav = this.favorites[i];
                var entity = fav.entity;
                
                if (entity.dimension != dimension) {
                    continue;
                }
                
                var species = fav.species;

                var icon;
                if (species) {
                    icon = "pf/image/" + species.id + "_small.png";
                } else {
                    icon = "pf/image/all_small.png";
                }
                var name  = this.getEntityFullName(entity, species);
                var color = fav.color;

                rowData.push({ s_icon   : {icon       : icon,
                                           iconWidth  : 16, 
                                           iconHeight : 16    },
                               name     : {text       : name  },
                               color    : {text       : color,
                                           textColor  : color },
                               favorite : fav
                             });
            }
            lv.update();
        },


        renderTabPage : function(label, icon, checked)
        {
            var tab_id, page_id;
            
            tab_id = new qx.legacy.ui.pageview.tabview.Button(label, icon);
            this.tabbar.add(tab_id);
            page_id = new qx.legacy.ui.pageview.tabview.Page(tab_id);
            page_id.setHeight("100%");
            page_id.setPadding(10, 10, 10, 10);
            page_id.setBackgroundColor("white");
            this.tabpane.add(page_id);

            if (checked) {
                tab_id.setChecked(true);
            }
            
            return page_id;
        },

        renderParametersTab : function()
        {
            var page_id = this.renderTabPage("Parameters",
                "pf/image/tab-parameters.png", true);

            var fr, gl, rc, rc1, rc2;

            rc = new qx.legacy.ui.layout.HorizontalBoxLayout;
            rc.setWidth("100%");
            rc.setHeight("auto");
            rc.setSpacing(1);
            page_id.add(rc);
            
            rc1 = new qx.legacy.ui.layout.VerticalBoxLayout;
            rc1.setWidth("50%");
            rc1.setHeight("auto");
            rc1.setSpacing(2);
            rc.add(rc1);
            
            rc2 = new qx.legacy.ui.layout.VerticalBoxLayout;
            rc2.setWidth("50%");
            rc2.setHeight("auto");
            rc2.setSpacing(2);
            rc.add(rc2);
            
            fr = new qx.legacy.ui.groupbox.GroupBox("Electrons",
                "pf/image/e_small.png");
            fr.setDimension("100%", "auto");
            fr.setBackgroundColor("#eeeeff");
            fr.getLegendObject().setBackgroundColor("#eeeeff");

            rc1.add(fr);

            gl = new qx.legacy.ui.layout.GridLayout;
            gl.setWidth("100%");
            gl.setVerticalSpacing(4);
            gl.setHorizontalSpacing(6);
            gl.setColumnCount(2);
            gl.setColumnWidth(0, "25%");
            gl.setColumnWidth(1, "75%");
            gl.setRowCount(2);
            gl.setRowHeight(0, 30);
            gl.setRowHeight(1, 30);

            fr.add(gl);

            var l, e;

            // N_e
            l = new qx.legacy.ui.basic.Label("N<sub>e</sub> (cm<sup>-3</sup>):");
            gl.add(l, 0, 0);
            e = new pf.ui.TextField(this.e.getN());
            gl.add(e, 1, 0);
            e.addListener("changeValue", changeN_e, this);
            this.gui_N_e = e;

            // T_e
            l = new qx.legacy.ui.basic.Label("T<sub>e</sub> (eV):");
            gl.add(l, 0, 1);
            e = new pf.ui.TextField(this.e.getT());
            gl.add(e, 1, 1);
            e.addListener("changeValue", changeT_e, this);
            this.gui_T_e = e;


            fr = new qx.legacy.ui.groupbox.GroupBox("Ions",
                "pf/image/i_small.png");
            fr.setDimension("100%", "auto");
            fr.setBackgroundColor("#ffeeee");
            fr.getLegendObject().setBackgroundColor("#ffeeee");

            rc1.add(fr);

            gl = new qx.legacy.ui.layout.GridLayout;
            gl.setWidth("100%");
            gl.setVerticalSpacing(4);
            gl.setHorizontalSpacing(6);
            gl.setColumnCount(2);
            gl.setColumnWidth(0, "25%");
            gl.setColumnWidth(1, "75%");
            gl.setRowCount(4);
            gl.setRowHeight(0, 30);
            gl.setRowHeight(1, 30);
            gl.setRowHeight(2, 30);
            gl.setRowHeight(3, 30);

            fr.add(gl);

            // Z_i
            l = new qx.legacy.ui.basic.Label("Z<sub>i</sub>:");
            gl.add(l, 0, 0);
            e = new pf.ui.Spinner(1, this.i.getQ(), 100);
            gl.add(e, 1, 0);
            e.addListener("change", changeZ_i, this);
            this.gui_Z_i = e;
            
            // M_i
            l = new qx.legacy.ui.basic.Label("M<sub>i</sub>:");
            gl.add(l, 0, 1);
            e = new pf.ui.Spinner(1, this.i.getM(), 200);
            gl.add(e, 1, 1);
            e.addListener("change", changeM_i, this);
            this.gui_M_i = e;
            
            // T_i
            l = new qx.legacy.ui.basic.Label("T<sub>i</sub> (eV):");
            gl.add(l, 0, 2);
            e = new pf.ui.TextField(this.i.getT());
            gl.add(e, 1, 2);
            e.addListener("changeValue", changeT_i, this);
            this.gui_T_i = e;

            // N_i
            l = new qx.legacy.ui.basic.Label("N<sub>i</sub> (cm<sup>-3</sup>):");
            gl.add(l, 0, 3);
            e = new pf.ui.TextField(this.i.getN());
            gl.add(e, 1, 3);
            e.setReadOnly(true);
            this.gui_N_i = e;
            
            
            fr = new qx.legacy.ui.groupbox.GroupBox("Radiators",
                "pf/image/r_small.png");
            fr.setDimension("100%", "auto");
            fr.setBackgroundColor("#eeffee");
            fr.getLegendObject().setBackgroundColor("#eeffee");

            rc2.add(fr);

            gl = new qx.legacy.ui.layout.GridLayout;
            gl.setWidth("100%");
            gl.setVerticalSpacing(4);
            gl.setHorizontalSpacing(6);
            gl.setColumnCount(2);
            gl.setColumnWidth(0, "25%");
            gl.setColumnWidth(1, "75%");
            gl.setRowCount(5);
            gl.setRowHeight(0, 30);
            gl.setRowHeight(1, 30);
            gl.setRowHeight(2, 30);
            gl.setRowHeight(3, 30);
            gl.setRowHeight(4, 30);

            fr.add(gl);


            // Z_r
            l = new qx.legacy.ui.basic.Label("Z<sub>r</sub>:");
            gl.add(l, 0, 0);
            e = new pf.ui.Spinner(0, this.r.getQ(), 100);
            gl.add(e, 1, 0);
            e.addListener("change", changeZ_r, this);
            this.gui_Z_r = e;

            // M_r
            l = new qx.legacy.ui.basic.Label("M<sub>r</sub>:");
            gl.add(l, 0, 1);
            e = new pf.ui.Spinner(1, this.r.getM(), 200);
            gl.add(e, 1, 1);
            e.addListener("change", changeM_r, this);
            this.gui_M_r = e;

            // T_r
            l = new qx.legacy.ui.basic.Label("T<sub>r</sub> (eV):");
            gl.add(l, 0, 2);
            e = new pf.ui.TextField(this.r.getT());
            gl.add(e, 1, 2);
            e.addListener("changeValue", changeT_r, this);
            this.gui_T_r = e;

            // P_r
            l = new qx.legacy.ui.basic.Label("P<sub>r</sub> (%):");
            gl.add(l, 0, 3);
            e = new pf.ui.Spinner(0, 100*this.P_r, 100);
            gl.add(e, 1, 3);
            e.addListener("change", changeP_r, this);
            this.gui_P_r = e;

            // N_r
            l = new qx.legacy.ui.basic.Label("N<sub>r</sub> (cm<sup>-3</sup>):");
            gl.add(l, 0, 4);
            e = new pf.ui.TextField(this.r.getN());
            e.setReadOnly(true);
            gl.add(e, 1, 4);
            this.gui_N_r = e;


            fr = new qx.legacy.ui.groupbox.GroupBox("Fields",
                "pf/image/field_small.png");
            fr.setDimension("100%", "auto");
            fr.setBackgroundColor("#ffffdd");
            fr.getLegendObject().setBackgroundColor("#ffffdd");

            rc1.add(fr);

            gl = new qx.legacy.ui.layout.GridLayout;
            gl.setWidth("100%");
            gl.setVerticalSpacing(4);
            gl.setHorizontalSpacing(6);
            gl.setColumnCount(2);
            gl.setColumnWidth(0, "25%");
            gl.setColumnWidth(1, "75%");
            gl.setRowCount(1);
            gl.setRowHeight(0, 30);

            fr.add(gl);


            l = new qx.legacy.ui.basic.Label("B (T):");
            gl.add(l, 0, 0);
            e = new pf.ui.TextField(this.B);
            gl.add(e, 1, 0);
            e.addListener("changeValue", changeB, this);
            this.gui_B = e;

            // Atomic system frame
            fr = new qx.legacy.ui.groupbox.GroupBox("Atomic system",
                "pf/image/all_small.png");
            fr.setDimension("100%", "auto");
            fr.setBackgroundColor("#ffffdd");
            fr.getLegendObject().setBackgroundColor("#ffffdd");

            rc2.add(fr);

            gl = new qx.legacy.ui.layout.GridLayout;
            gl.setWidth("100%");
            gl.setVerticalSpacing(4);
            gl.setHorizontalSpacing(6);
            gl.setColumnCount(2);
            gl.setColumnWidth(0, "25%");
            gl.setColumnWidth(1, "75%");
            gl.setRowCount(3);
            gl.setRowHeight(0, 30);
            gl.setRowHeight(1, 30);
            gl.setRowHeight(2, 30);

            fr.add(gl);

            l = new qx.legacy.ui.basic.Label("Z<sub>core</sub>:");
            gl.add(l, 0, 0);
            e = new qx.legacy.ui.form.TextField(this.r.getQ() + 1);
            e.setReadOnly(true);
            gl.add(e, 1, 0);
            this.gui_Zcore = e;

            l = new qx.legacy.ui.basic.Label("n<sub>u</sub>:");
            gl.add(l, 0, 1);
            e = new pf.ui.Spinner(2, this.n_u, 1000);
            gl.add(e, 1, 1);
            e.addListener("change", changeN_u, this);
            this.gui_n_u = e;

            l = new qx.legacy.ui.basic.Label("n<sub>l</sub>:");
            gl.add(l, 0, 2);
            e = new pf.ui.Spinner(1, this.n_l, 1000);
            gl.add(e, 1, 2);
            e.addListener("change", changeN_l, this);
            this.gui_n_l = e;
        },

        renderExplorerTab : function()
        {
            var page_id = this.renderTabPage("Explorer",
                "pf/image/tab-explorer.png", false);
            
            var sp = new qx.legacy.ui.splitpane.HorizontalSplitPane(300, "1*");
            sp.set(
            {
                left            : 1,
                right           : 1,
                top             : 1,
                bottom          : 1,
                border          : "inset-thin",
                showKnob        : true
            });
            page_id.add(sp);
                        
            var left_pane  = sp.getLeftArea();
            left_pane.setBackgroundColor("white");
            left_pane.setBorder("inset-thin");
            var right_pane = sp.getRightArea();
            right_pane.setBackgroundColor("white");
            right_pane.setBorder("inset-thin");
            var tree = new qx.legacy.ui.tree.Tree("Browser");
            tree.set(
            {
                overflow        : "scroll",
                height          : "100%",
                width           : "100%",
                paddingLeft     : 4,
                paddingTop      : 4
            });
            left_pane.add(tree);
            
            this.entity_tree = tree;
            
            var folder;
            
            folder = new qx.legacy.ui.tree.TreeFolder("Frequency");
            folder.setAlwaysShowPlusMinusSymbol(true);
            folder.addListener("changeSelected", clickTreeCB, this);
            tree.add(folder);
            this.gui_folder_freq = folder;

            folder = new qx.legacy.ui.tree.TreeFolder("Length");
            folder.setAlwaysShowPlusMinusSymbol(true);
            folder.addListener("changeSelected", clickTreeCB, this);
            tree.add(folder);
            this.gui_folder_length = folder;
            
            folder = new qx.legacy.ui.tree.TreeFolder("Velocity");
            folder.setAlwaysShowPlusMinusSymbol(true);
            folder.addListener("changeSelected", clickTreeCB, this);
            tree.add(folder);
            this.gui_folder_vel = folder;
            
            folder = new qx.legacy.ui.tree.TreeFolder("Dimensionless");
            folder.setAlwaysShowPlusMinusSymbol(true);
            folder.addListener("changeSelected", clickTreeCB, this);
            tree.add(folder);
            this.gui_folder_none = folder;

            folder = new qx.legacy.ui.tree.TreeFolder("Energy");
            folder.setAlwaysShowPlusMinusSymbol(true);
            folder.addListener("changeSelected", clickTreeCB, this);
            tree.add(folder);
            this.gui_folder_energy = folder;

            folder = new qx.legacy.ui.tree.TreeFolder("Pressure");
            folder.setAlwaysShowPlusMinusSymbol(true);
            folder.addListener("changeSelected", clickTreeCB, this);
            tree.add(folder);
            this.gui_folder_pressure = folder;

            folder = new qx.legacy.ui.tree.TreeFolder("Area");
            folder.setAlwaysShowPlusMinusSymbol(true);
            folder.addListener("changeSelected", clickTreeCB, this);
            tree.add(folder);
            this.gui_folder_area = folder;

            folder = new qx.legacy.ui.tree.TreeFolder("Power density");
            folder.setAlwaysShowPlusMinusSymbol(true);
            folder.addListener("changeSelected", clickTreeCB, this);
            tree.add(folder);
            this.gui_folder_power_density = folder;

            folder = new qx.legacy.ui.tree.TreeFolder("Power spectral density");
            folder.setAlwaysShowPlusMinusSymbol(true);
            folder.addListener("changeSelected", clickTreeCB, this);
            tree.add(folder);
            this.gui_folder_spectral_power_density = folder;

            folder = new qx.legacy.ui.tree.TreeFolder("Miscellaneous");
            folder.setAlwaysShowPlusMinusSymbol(true);
            folder.addListener("changeSelected", clickTreeCB, this);
            tree.add(folder);
            this.gui_folder_misc = folder;

            this.populateTree();

            tree.setHideNode(true);
            tree.setRootOpenClose(true);
            
            // Build context-sensitive popup menu
            this.treeMenu = new qx.legacy.ui.menu.Menu;
            var button;
            
            button = new qx.legacy.ui.menu.Button("Add to Favorites",
                "pf/image/favorite-add.png");
            button.addListener("execute", addToFavCB, this);
            this.treeMenu.add(button);
            this.treeMenuButtonAddToFav = button;
            button = new qx.legacy.ui.menu.Button("Remove from Favorites",
                "pf/image/favorite-delete.png");
            button.addListener("execute", removeFromFavCB, this);
            this.treeMenu.add(button);
            this.treeMenuButtonRemFromFav = button;
            
            this.doc.add(this.treeMenu);


            var vbl = new qx.legacy.ui.layout.VerticalBoxLayout("vertical");
            vbl.set(
            {
                height          : "100%",
                width           : "100%",
                padding         : 4,
                spacing         : 10
            });
            right_pane.add(vbl);

            var gl = new qx.legacy.ui.layout.GridLayout;
            gl.set(
            {
                height            : "auto",
                left              : 4,
                right             : 4,
                top               : 4,
                verticalSpacing   : 4,
                horizontalSpacing : 6
            });
            
            gl.setColumnCount(3);
            gl.setColumnWidth(0, "15%");
            gl.setColumnWidth(1, "60%");
            gl.setColumnWidth(2, "20%");
            gl.setRowCount(3);
            gl.setRowHeight(0, 30);
            gl.setRowHeight(1, 30);
            gl.setRowHeight(2, 30);

            var l, e;

            l = new qx.legacy.ui.basic.Label("Name:");
            gl.add(l, 0, 0);
            e = new qx.legacy.ui.form.TextField();
            e.setReadOnly(true);
            this.gui_entity_name = e;
            gl.add(e, 1, 0);

            l = new qx.legacy.ui.basic.Label("Value:");
            gl.add(l, 0, 1);
            e = new pf.ui.TextField("");
            e.setReadOnly(true);
            gl.add(e, 1, 1);
            this.gui_entity_value = e;

            e = new pf.UnitSelector();
            e.addListener("changeSelected", changeUnitsCB, this);
            gl.add(e, 2, 1);
            this.gui_entity_units = e;

            l = new qx.legacy.ui.basic.Label("Section:");
            gl.add(l, 0, 2);
            e = new qx.legacy.ui.form.TextField();
            e.setReadOnly(true);
            this.gui_entity_section = e;
            gl.add(e, 1, 2);

            vbl.add(gl);
            
            var frame = new qx.legacy.ui.embed.Iframe();
            frame.set({ width : '100%', height : '2*' });
            
            vbl.add(frame);
            
            this.gui_wiki = frame;
        },
        
        renderCompareTab : function()
        {
            var page_id = this.renderTabPage("Compare",
                "pf/image/tab-compare.png");
            
            var bl = new qx.legacy.ui.layout.VerticalBoxLayout("vertical");
            bl.setWidth("100%");
            bl.setHeight("100%");
            bl.setSpacing(10);
            page_id.add(bl);
            
            var rc = new qx.legacy.ui.layout.HorizontalBoxLayout;
            rc.setWidth("100%");
            rc.setHeight("auto");
            rc.setSpacing(10);
            bl.add(rc);

            var l, e;
            l = new qx.legacy.ui.basic.Label("Dimension:");
            e = new pf.ui.ComboBox;
            e.add(new qx.legacy.ui.form.ListItem("Frequency", null, "frequency"));
            e.add(new qx.legacy.ui.form.ListItem("Length", null, "length"));
            e.add(new qx.legacy.ui.form.ListItem("Velocity", null, "velocity"));
            e.add(new qx.legacy.ui.form.ListItem("Energy", null, "energy"));
            e.add(new qx.legacy.ui.form.ListItem("Pressure", null, "pressure"));
            e.add(new qx.legacy.ui.form.ListItem("Area", null, "area"));
            e.add(new qx.legacy.ui.form.ListItem("Power density", null, "power_density"));
            e.add(new qx.legacy.ui.form.ListItem("Power spectral density",
                null, "spectral_power_density"));
            e.add(new qx.legacy.ui.form.ListItem("Electric field", null, "efield"));
            e.add(new qx.legacy.ui.form.ListItem("None", null, "none"));
            e.addListener("changeSelected", function(ev) {
                    var dimension = this.gui_compare_dim.getSelectedValue();
                    this.gui_compare_units.update(dimension,
                        this.prefs.units[dimension]);
                    this.updateFavoritesListView();
                    this.updateLegendListView();
                }, this);
            rc.add(l, e);
            this.gui_compare_dim = e;

            l = new qx.legacy.ui.basic.Label("Units:");
            e = new pf.UnitSelector();
            e.addListener("changeSelected", function(ev) {
                    this.updateFavoritesListView();
                }, this);
            rc.add(l, e);
            this.gui_compare_units = e;

            var lc =
            {
                s_icon   : { label      : "",
                             width      : 24,
                             type       : "iconHtml",
                             align      : "center",                    
                             sortable   : false                         },
                name     : { label      : "Name",
                             width      : 300,
                             type       : "text",
                             align      : "left",
                             sortable   : true,
                             sortProp   : "text"                        },
                section  : { label      : "Section",
                             width      : 120,
                             type       : "text",
                             align      : "left",
                             sortable   : true,
                             sortProp   : "text"                        },
                value    : { label      : "Value",
                             width      : 120,
                             type       : "text",
                             align      : "right",
                             sortable   : true,
                             sortProp   : "text",
                             sortMethod : qx.legacy.util.Compare.byFloatString }
            };

            var lv = new qx.legacy.ui.listview.ListView(new Array, lc);

            lv.setWidth("100%");
            lv.setHeight("2*");
            lv.setBackgroundColor("white");
            lv.setBorder("dark-shadow");

            bl.add(lv);
            
            this.favoritesListView = lv;
        },
        
        drawAll : function(ev)
        {
            var canvas = this.canvas;
            
            canvas.setPrintable(true);
            
            var pname = this.guiParameter.getValue();
            var vmin = this.guiMinParam.getNumValue();
            var vmax = this.guiMaxParam.getNumValue();
            var npoints = this.guiParamPoints.getValue();
            
            if (npoints < 2 || !pname) {
                return;
            }

            var dimension = this.gui_compare_dim.getSelectedValue();
            var scale = this.gui_compare_units.getSelectedValue();

            var par0;
            var label;
            switch (pname) {
            case "N_e":
                par0 = this.e.getN();
                label = "N<sub>e</sub> (cm<sup>-3</sup>)"
                break;
            case "T":
                par0 = this.e.getT();
                label = "T (eV)"
                break;
            case "T_e":
                par0 = this.e.getT();
                label = "T<sub>e</sub> (eV)"
                break;
            case "T_i":
                par0 = this.i.getT();
                label = "T<sub>i</sub> (eV)"
                break;
            case "T_r":
                par0 = this.r.getT();
                label = "T<sub>r</sub> (eV)"
                break;
            case "T_i,r":
                par0 = this.i.getT();
                label = "T<sub>i,r</sub> (eV)"
                break;
            case "B":
                par0 = this.B;
                label = "B (T)"
                break;
            default:
                return;
            }
            
            var xdata = new Array;
            for (var j = 0; j < npoints; j++) {
                var x = par0*(vmin + (vmax - vmin)*j/(npoints - 1));
                xdata.push(x);
            }
                        
            var wxmin = xdata[0];
            var wxmax = xdata[xdata.length - 1];

            var wymin = 0;
            var wymax = 0;

            var sets = new Array;
            var first = true;
            for (var i = 0; i < this.favorites.length; i++) {
                var fav = this.favorites[i];
                var entity = fav.entity;
                
                if (entity.dimension != dimension) {
                    continue;
                }
                
                var species = fav.species;
                var vname = this.getEntityFullName(entity, species);

                var set   = new Array;
                var ydata = new Array;
                for (var j = 0; j < npoints; j++) {
                    var par = xdata[j];

                    switch (pname) {
                    case "N_e":
                        this.e.setN(par);
                        this.updatePlasmaParameters();
                        break;
                    case "T_e":
                        this.e.setT(par);
                        break;
                    case "T_i":
                        this.i.setT(par);
                        break;
                    case "T_r":
                        this.r.setT(par);
                        break;
                    case "T_i,r":
                        this.i.setT(par);
                        this.r.setT(par);
                        break;
                    case "T":
                        this.e.setT(par);
                        this.i.setT(par);
                        this.r.setT(par);
                        break;
                    case "B":
                        this.B = par;
                        break;
                    }
                    
                    var value = scale*this.evaluateEntityValue(entity, species);
                    
                    if (first) {
                        wymin = value;
                        wymax = value;
                        first = false;
                    } else {
                        if (value < wymin) {
                            wymin = value;
                        }
                        if (value > wymax) {
                            wymax = value;
                        }
                    }
                    
                    ydata.push(value);
                }
                set.x = xdata;
                set.y = ydata;
                set.legend = vname;
                set.color = fav.color;
                sets.push(set);
            }
            
            // Restore parameter
            switch (pname) {
            case "N_e":
                this.e.setN(par0);
                this.updatePlasmaParameters();
                break;
            case "T_e":
                this.e.setT(par0);
                break;
            case "T_i":
                this.i.setT(par0);
                break;
            case "T_r":
                this.r.setT(par0);
                break;
            case "T_i,r":
                this.i.setT(par0);
                this.r.setT(par0);
                break;
            case "T":
                this.e.setT(par0);
                this.i.setT(par0);
                this.r.setT(par0);
                break;
            case "B":
                this.B = par0;
                break;
            }
            
            canvas.clear();
            
            canvas.setViewportCoordinates(0.15, 0.1, 0.9, 0.9);
            dwx = Math.abs(wxmax - wxmin);
            if (dwx == 0) {
                dwx = wxmax;
            }
            dwy = Math.abs(wymax - wymin);
            if (dwy == 0) {
                wymin = 0.0;
                if (wymax == 0) {
                    wymax = 1.0;
                } else {
                    wymax *= 2;
                }
            }
            canvas.setWorldCoordinates(Math.max(0, wxmin - 0.05*dwx),
                Math.max(0, wymin - 0.05*dwy),
                wxmax + 0.05*dwx, wymax + 0.05*dwy);
            
            // Draw frame
            canvas.drawFrame("black");

            // Mark initial value of the varied parameter
            canvas.setColor("#c0c0c0");
            canvas.drawPolyLineW(new Array(par0, par0),
                new Array(wymin, wymax));
            
            // Draw axis ticks
            canvas.drawTicks("x", "blue");
            canvas.drawTicks("y", "blue");

            // Draw axis labels
            canvas.drawLabel("x", label, "black");
            
            // Draw sets
            for (var i = 0; i < sets.length; i++) {
                var set = sets[i];
                canvas.setColor(set.color);
                canvas.drawPolyLineW(set.x, set.y);
                
                delete set;
            }
            
            delete sets;
            
            canvas.paint();
        },

        showWikiPage : function(entity)
        {
            var url;
            if (entity && entity.wikiLink) {
                url = "http://en.wikipedia.org/w/index.php?title=" +
                      entity.wikiLink + "&printable=yes";
            } else {
                url = null;
            }
            
            this.gui_wiki.setSource(url);
        },
        
        loadWikiCB : function(ev)
        {
            var tree = this.entity_tree;
            var leaf = tree.getSelectedElement();
            
            if (!leaf) {
                return;
            }
            
            var entity = leaf.getUserData("entity");
            
            this.showWikiPage(entity);
        },
        
        drawCB : function(ev)
        {
            this.drawAll();
        },
        
        renderPlotTab : function()
        {
            var page_id = this.renderTabPage("Plot",
                "pf/image/tab-plot.png");

            var sp = new qx.legacy.ui.splitpane.HorizontalSplitPane("1*", 300);
            sp.set(
            {
                height          : "100%",
                width           : "100%",
                left            : 1,
                right           : 1,
                top             : 1,
                bottom          : 1,
                border          : "inset-thin",
                showKnob        : true
            });
            page_id.add(sp);
                        
            var left_pane  = sp.getLeftArea();
            left_pane.setBackgroundColor("white");
            left_pane.setBorder("inset-thin");
            var right_pane = sp.getRightArea();
            right_pane.setBackgroundColor("white");
            right_pane.setBorder("inset-thin");

            var canvas = new pf.ui.canvas.Plotter();
            canvas.set(
            {
                height          : "100%",
                width           : "100%"
            });
            left_pane.add(canvas);
            this.canvas = canvas;


            var vbl = new qx.legacy.ui.layout.VerticalBoxLayout("vertical");
            vbl.set(
            {
                height          : "100%",
                width           : "100%",
                padding         : 4,
                spacing         : 10
            });
            right_pane.add(vbl);

            var gl = new qx.legacy.ui.layout.GridLayout;
            gl.set(
            {
                height            : "auto",
                width             : "100%",
                left              : 4,
                right             : 4,
                top               : 4,
                verticalSpacing   : 4,
                verticalSpacing   : 4,
                horizontalSpacing : 6
            });
            
            gl.setColumnCount(2);
            gl.setColumnWidth(0, 150);
            gl.setColumnWidth(1, 100);
            gl.setRowCount(5);
            gl.setRowHeight(0, 30);
            gl.setRowHeight(1, 30);
            gl.setRowHeight(2, 30);
            gl.setRowHeight(3, 30);
            gl.setRowHeight(4, 30);
            vbl.add(gl);

            var l, e;

            var btn = new qx.legacy.ui.form.Button("Redraw", "pf/image/tab-plot.png");
            btn.addListener("execute", this.drawCB, this);
            gl.add(btn, 0, 0);

            l = new qx.legacy.ui.basic.Label("Parameter to vary:");
            e = new pf.ui.ComboBox;
            e.add(new qx.legacy.ui.form.ListItem("N_e",   null, "N_e"));
            e.add(new qx.legacy.ui.form.ListItem("T",     null, "T"));
            e.add(new qx.legacy.ui.form.ListItem("T_e",   null, "T_e"));
            e.add(new qx.legacy.ui.form.ListItem("T_i",   null, "T_i"));
            e.add(new qx.legacy.ui.form.ListItem("T_r",   null, "T_r"));
            e.add(new qx.legacy.ui.form.ListItem("T_i,r", null, "T_i,r"));
            e.add(new qx.legacy.ui.form.ListItem("B",     null, "B"));
            e.selectByValue("N_e");
            this.guiParameter = e;
            gl.add(l, 0, 1);
            gl.add(e, 1, 1);

            l = new qx.legacy.ui.basic.Label("Minimum scale:");
            e = new pf.ui.TextField(0.3);
            this.guiMinParam = e;
            gl.add(l, 0, 2);
            gl.add(e, 1, 2);

            l = new qx.legacy.ui.basic.Label("Maximum scale:");
            e = new pf.ui.TextField(3.0);
            this.guiMaxParam = e;
            gl.add(l, 0, 3);
            gl.add(e, 1, 3);

            l = new qx.legacy.ui.basic.Label("Number of points:");
            e = new pf.ui.Spinner(2, 20, 100);
            this.guiParamPoints = e;
            gl.add(l, 0, 4);
            gl.add(e, 1, 4);


            var lc =
            {
                s_icon   : { label      : "",
                             width      : 24,
                             type       : "iconHtml",
                             align      : "center",                    
                             sortable   : false                         },
                name     : { label      : "Name",
                             width      : 185,
                             type       : "text",
                             align      : "left",
                             sortable   : true,
                             sortProp   : "text"                        },
                color    : { label      : "Color",
                             width      : 55,
                             type       : "text",
                             align      : "left",
                             sortable   : false                         }
            };

            var lv = new qx.legacy.ui.listview.ListView(new Array, lc);

            lv.setWidth("100%");
            lv.setHeight("2*");
            // lv.setBackgroundColor("white");
            lv.setBorder("dark-shadow");
            
            lv.addListener("dblclick", function(ev) {
                    ev.stopPropagation();
                    var pane = this.getPane();
                    var item = pane.getSelectedItem();
                    if (!item) {
                        return;
                    }
                    var favorite = item.favorite;
                    if (!favorite) {
                        return;
                    }
                    mypop.setUserData("favorite", null); // avoid loop call
                    mypop.setValue(favorite.color);
                    mypop.setUserData("favorite", favorite);
                    var el = this.getElement();
                    mypop.setTop(qx.legacy.html.Location.getPageBoxTop(el));
                    mypop.setLeft(qx.legacy.html.Location.getPageBoxLeft(el) -
                        this.getWidthValue());
                    mypop.show();
                });

            vbl.add(lv);
            this.legendListView = lv;
            
            var mytables =
            {
              core : {
                label : "Basic Colors",
                values : this.colorMap
              },

              recent : {
                label : "Recent Colors",
                values : [ ]
              }
            }

            var mypop = new qx.legacy.ui.component.ColorPopup(mytables);
            // A hack
            mypop._layout.remove(mypop._automaticBtn);

            mypop.addToDocument();

            mypop.addListener("changeValue", function(ev) {
                var color = ev.getValue();
                var mypop = ev.getTarget();
                var favorite = mypop.getUserData("favorite");
                if (!favorite || !color) {
                    return;
                }
                favorite.color = color;
                this.updateLegendListView();
                this.drawAll();
            }, this);
    
        },


        aboutCB : function(ev)
        {
            this.aboutWindow.open();
        },
        
        prefsCB : function(ev)
        {
            this.prefsWindow.open();
        },
        
        updateSaveLoadList : function()
        {
            var lv = this.saveLoadConfigList;
            var configPtrs = this.prefs.configPtrs;
            
            var rowData = lv.getData();
            rowData.length = 0;
            lv.getPane().getManager().deselectAll();

            var i;
            var d = new Date();
            var df = new qx.util.format.DateFormat("yyyy-MM-dd HH:mm:ss");
            
            for (i = 0; i < configPtrs.length; i++) {
                var configPtr = configPtrs[i];

                d.setTime(configPtr.time);

                rowData.push({ name : {text       : configPtr.name },
                               date : {text       : df.format(d)   }
                             });
            }
            
            lv.updateSort();
            lv.update();
        },
        
        saveAsCB : function(ev)
        {
            var w = this.saveLoadWindow;
            
            this.updateSaveLoadList();
            this.saveLoadTextField.setValue(null);
            this.saveLoadTextField.setReadOnly(false);
            
            w.setCaption("Save configuration")
            w.setIcon("pf/image/save.png");
            w.setUserData("type", "save");
            
            w.open();
        },
        
        saveConfigCB : function(ev)
        {
            if (this.prefs.currentConfigName) {
                if (this.saveConfig(this.prefs.currentConfigName) != true) {
                    alert("Save failed!");
                }
            } else {
                this.saveAsCB(ev);
            }
        },
        
        openCB : function(ev)
        {
            var w = this.saveLoadWindow;
            
            this.updateSaveLoadList();
            this.saveLoadTextField.setValue(null);
            this.saveLoadTextField.setReadOnly(true);
            
            w.setCaption("Open configuration")
            w.setIcon("pf/image/open.png");
            w.setUserData("type", "open");
            
            w.open();
        },
        
        buildMenu : function()
        {
            var menubar = this.menubar;
            
            var submenu, btn, q;

            var theme = qx.legacy.theme.manager.Color.getInstance().getColorTheme();
            var bg = '#' +
                qx.util.ColorUtil.rgbToHexString(theme.colors['button']);
            
            submenu = new qx.legacy.ui.menu.Menu;
            submenu.setBackgroundColor(bg);
            this.doc.add(submenu);
            q = new qx.event.Command("Ctrl+O");
            q.addListener("execute", this.openCB, this);
            btn = new qx.legacy.ui.menu.Button("Open...", "pf/image/open.png", q);
            submenu.add(btn);
            q = new qx.event.Command("Ctrl+S");
            q.addListener("execute", this.saveConfigCB, this);
            btn = new qx.legacy.ui.menu.Button("Save", "pf/image/save.png", q);
            submenu.add(btn);
            btn = new qx.legacy.ui.menu.Button("Save as...", "pf/image/save.png");
            btn.addListener("execute", this.saveAsCB, this);
            submenu.add(btn);
            submenu.add(new qx.legacy.ui.menu.Separator);
            q = new qx.event.Command("Ctrl+P");
            q.addListener("execute", function(ev) {
                window.print();
            });
            btn = new qx.legacy.ui.menu.Button("Print...", "pf/image/print.png", q);
            submenu.add(btn);
            submenu.add(new qx.legacy.ui.menu.Separator);
            q = new qx.event.Command("Ctrl+R");
            q.addListener("execute", function(ev) {
                location.reload(true);
            });
            btn = new qx.legacy.ui.menu.Button("Restart", "pf/image/reset.png", q);
            submenu.add(btn);
            submenu.add(new qx.legacy.ui.menu.Separator);
            q = new qx.event.Command("Ctrl+Q");
            q.addListener("execute", function(ev) {
                window.close();
            });
            btn = new qx.legacy.ui.menu.Button("Quit", "pf/image/exit.png", q);
            submenu.add(btn);
                
            btn = new qx.legacy.ui.menubar.Button("File", submenu);
            btn.set({ paddingLeft : 7, paddingRight : 7 });
            menubar.add(btn);


            submenu = new qx.legacy.ui.menu.Menu;
            submenu.setBackgroundColor(bg);
            submenu.addListener("beforeAppear", editMenuCB, this);
            this.doc.add(submenu);
            btn = new qx.legacy.ui.menu.Button("Add to Favorites",
                "pf/image/favorite-add.png");
            btn.addListener("execute", addToFavCB, this);
            this.editMenuButtonAddToFav = btn;
            submenu.add(btn);
            btn = new qx.legacy.ui.menu.Button("Remove from Favorites",
                "pf/image/favorite-delete.png");
            btn.addListener("execute", removeFromFavCB, this);
            this.editMenuButtonRemFromFav = btn;
            submenu.add(btn);
            submenu.add(new qx.legacy.ui.menu.Separator);
            btn = new qx.legacy.ui.menu.Button("Preferences",
                "pf/image/preferences.png");
            btn.addListener("execute", this.prefsCB, this);
            submenu.add(btn);

            btn = new qx.legacy.ui.menubar.Button("Edit", submenu);
            btn.set({ paddingLeft : 7, paddingRight : 7 });
            menubar.add(btn);


            submenu = new qx.legacy.ui.menu.Menu;
            submenu.setBackgroundColor(bg);
            submenu.addListener("beforeAppear", viewMenuCB, this);

            var subMenu1 = new qx.legacy.ui.menu.Menu;
            subMenu1.setBackgroundColor(bg);
            button = new qx.legacy.ui.menu.CheckBox("Fundamental",
                null, this.showFundamental);
            button.addListener("execute", showFundamentalCB, this);
            subMenu1.add(button);
            button = new qx.legacy.ui.menu.CheckBox("Spectroscopy",
                null, this.showSpectroscopy);
            button.addListener("execute", showSpectroscopyCB, this);
            subMenu1.add(button);
            button = new qx.legacy.ui.menu.CheckBox("Waves",
                null, this.showWaves);
            button.addListener("execute", showWavesCB, this);
            subMenu1.add(button);
            button = new qx.legacy.ui.menu.CheckBox("Collisions",
                null, this.showCollisions);
            button.addListener("execute", showCollisionsCB, this);
            subMenu1.add(button);
            this.showSectionsButton = new qx.legacy.ui.menu.Button("Show Sections",
                null, null, subMenu1);
            submenu.add(this.showSectionsButton);
            
            submenu.add(new qx.legacy.ui.menu.Separator);

            var subMenu2 = new qx.legacy.ui.menu.Menu;
            subMenu2.setBackgroundColor(bg);
            button = new qx.legacy.ui.menu.CheckBox("Electrons",
                null, this.showElectrons)
            button.addListener("execute", showElectronsCB, this);
            subMenu2.add(button);
            button = new qx.legacy.ui.menu.CheckBox("Ions",
                null, this.showIons)
            button.addListener("execute", showIonsCB, this);
            subMenu2.add(button);
            button = new qx.legacy.ui.menu.CheckBox("Radiators",
                null, this.showRadiators)
            button.addListener("execute", showRadiatorsCB, this);
            subMenu2.add(button);
            this.showSpeciesButton = new qx.legacy.ui.menu.Button("Show Species",
                null, null, subMenu2);
            submenu.add(this.showSpeciesButton);
            
            submenu.add(new qx.legacy.ui.menu.Separator);
            q = new qx.event.Command("Ctrl+W");
            q.addListener("execute", this.loadWikiCB, this);
            btn = new qx.legacy.ui.menu.Button("Load Wikipedia Article",
                "pf/image/wikipedia.png", q);
            submenu.add(btn);
            this.loadWikiButton = btn;
            this.doc.add(submenu, subMenu1, subMenu2);

            submenu.add(new qx.legacy.ui.menu.Separator);
            q = new qx.event.Command("Ctrl+L");
            q.addListener("execute", this.drawCB, this);
            btn = new qx.legacy.ui.menu.Button("Redraw Plot",
                "pf/image/tab-plot.png", q);
            submenu.add(btn);
            this.redrawButton = btn;
            
            btn = new qx.legacy.ui.menubar.Button("View", submenu);
            btn.set({ paddingLeft : 7, paddingRight : 7 });
            menubar.add(btn);


            submenu = new qx.legacy.ui.menu.Menu;
            submenu.setBackgroundColor(bg);
            this.doc.add(submenu);
            q = new qx.event.Command("F1");
            q.addListener("execute", function(ev) {
                alert("Help system not implemented yet");
            });
            btn = new qx.legacy.ui.menu.Button("Help Contents",
                "pf/image/help.png", q);
            submenu.add(btn);
            btn = new qx.legacy.ui.menu.Button("NRL Plasma Formulary",
                "pf/image/nrl.png");
            btn.addListener("execute", function (ev) {
                    var w = new qx.legacy.util.NativeWindow("http://wwwppd.nrl.navy.mil/nrlformulary/");
                    w.setDimension(800, 600);
                    w.open();
                }, this);
            submenu.add(btn);
            btn = new qx.legacy.ui.menu.Button("Plasma at Wikipedia",
                "pf/image/wikipedia.png");
            btn.addListener("execute", function (ev) {
                    var w = new qx.legacy.util.NativeWindow("http://en.wikipedia.org/wiki/Plasma_%28physics%29");
                    w.setDimension(800, 600);
                    w.open();
                }, this);
            submenu.add(btn);
            submenu.add(new qx.legacy.ui.menu.Separator);
            btn = new qx.legacy.ui.menu.Button("About Plasma Formulary",
                "pf/image/about.png");
            btn.addListener("execute", this.aboutCB, this);
            submenu.add(btn);

            btn = new qx.legacy.ui.menubar.Button("Help", submenu);
            btn.set({ paddingLeft : 7, paddingRight : 7 });
            menubar.add(btn);
        },
        
        nextColor : function()
        {
            var color = this.colorMap[this.ncolor];
            this.ncolor++;
            if (this.ncolor == this.colorMap.length) {
                this.ncolor = 0;
            }
            
            return color;
        },

        getWindowDimensions : function()
        {
            var dims = new Object;
            
            dims.w = qx.legacy.html.Window.getInnerWidth(this.win);
            dims.h = qx.legacy.html.Window.getInnerHeight(this.win);
            
            return dims;
        },

        savePreferences : function()
        {
            if (this.prefs) {
                var prefstr = qx.util.Json.stringify(this.prefs);
                qx.legacy.io.local.CookieApi.set("pf_prefs", prefstr, 3650);
            }
        },
        
        loadPreferences : function()
        {
            var prefstr = qx.legacy.io.local.CookieApi.get("pf_prefs");
            
            if (prefstr) {
                this.prefs = qx.util.Json.parseQx(prefstr);
            }
            
            if (!this.prefs) {
                this.prefs = new Object;
            }
 
            if (undefined === this.prefs.rememberWindowSize) {
                this.prefs.rememberWindowSize = false;
            }

            if (undefined === this.prefs.autoLoadWiki) {
                this.prefs.autoLoadWiki = true;
            }
            
            if (!this.prefs.units) {
                this.prefs.units = new Object;
            }
            
            if (!this.prefs.configPtrs) {
                this.prefs.configPtrs = new Array;
            }
        },
        
        getConfig : function(name)
        {
            if (!name) {
                return null;
            }

            var configPtrs = this.prefs.configPtrs;
            
            var i, configPtr = null;
            for (i = 0; i < configPtrs.length; i++) {
                if (configPtrs[i].name == name) {
                    configPtr = configPtrs[i];
                    return configPtr;
                    break;
                }
            }
            
            return null;
        },
        
        saveConfig : function(name)
        {
            if (!name) {
                return false;
            }

            var configPtr = this.getConfig(name);
            
            var d = new Date();
            var time = d.getTime();
            
            if (!configPtr) {
                configPtr = new Object;
                configPtr.name = name;
                configPtr.hash = time;
                this.prefs.configPtrs.push(configPtr);
            }
            
            configPtr.time = time;
            
            var cookie_name = "pf_config_" + configPtr.hash;
            
            var config = new Object;
            
            config.N_e = this.e.getN();

            config.T_e = this.e.getT();
            config.T_i = this.i.getT();
            config.T_r = this.r.getT();

            config.M_i = this.i.getM();
            config.M_r = this.r.getM();
            
            config.Q_i = this.i.getQ();
            config.Q_r = this.r.getQ();

            config.P_r = this.P_r;

            config.B   = this.B  ;

            config.n_u = this.n_u;
            config.n_l = this.n_l;
            
            var configstr = qx.util.Json.stringify(config);
            qx.legacy.io.local.CookieApi.set(cookie_name, configstr, 3650);
            
            this.prefs.currentConfigName = name;
            
            return true;
        },
        
        loadConfig : function(name)
        {
            var configPtr = this.getConfig(name);
            if (!configPtr) {
                return false;
            }

            var cookie_name = "pf_config_" + configPtr.hash;

            var configstr = qx.legacy.io.local.CookieApi.get(cookie_name);
            if (!configstr) {
                // Cookie was deleted???
                qx.lang.Array.remove(this.prefs.configPtrs, configPtr);
                return false;
            }

            var config = qx.util.Json.parseQx(configstr);
            
            if (config) {
                this.e.setN(config.N_e);

                this.e.setT(config.T_e);
                this.i.setT(config.T_i);
                this.r.setT(config.T_r);

                this.i.setM(config.M_i);
                this.r.setM(config.M_r);

                this.i.setQ(config.Q_i);
                this.r.setQ(config.Q_r);

                this.P_r = config.P_r;

                this.B   = config.B  ;

                this.n_u = config.n_u;
                this.n_l = config.n_l;

                this.prefs.currentConfigName = name;

                return true;
            } else {
                return false;
            }
        },
        
        removeConfig : function(name)
        {
            var configPtr = this.getConfig(name);
            if (configPtr) {
                qx.lang.Array.remove(this.prefs.configPtrs, configPtr);
                var cookie_name = "pf_config_" + configPtr.hash;
                qx.legacy.io.local.CookieApi.set(cookie_name, null);
            }
        },
        
        renameConfig : function(oldname, newname)
        {
            var configPtr = this.getConfig(oldname);
            if (configPtr) {
                configPtr.name = newname;
            }
        },
        
        createSaveLoadDialog : function()
        {
            var w, rc, rc1, e, btn;
            // "Save as..." dialog
            w = new qx.legacy.ui.window.Window();
            w.setSpace(200, "auto", 100, 300);
            w.setModal(true);
            w.setShowMinimize(false);
            w.setShowMaximize(false);

            w.addListener("keypress", function(ev) {
                    if (ev.getKeyIdentifier() == "Escape") {
                        w.close()
                    }
                });

            rc = new qx.legacy.ui.layout.VerticalBoxLayout("vertical");
            rc.set({width : "100%", height : "100%", spacing : 4});
            w.add(rc);
            
            var tb = new qx.legacy.ui.toolbar.ToolBar();
            var btn_delete = new qx.legacy.ui.toolbar.Button("Delete",
                "pf/image/delete.png");
            var btn_rename = new qx.legacy.ui.toolbar.Button("Rename",
                "pf/image/rename.png");
            btn_delete.setEnabled(false);
            btn_rename.setEnabled(false);
            var sep = new qx.legacy.ui.toolbar.Separator();
            tb.add(sep, btn_delete, btn_rename);
            rc.add(tb);
            
            var lc =
            {
                name     : { label      : "Configuration",
                             width      : 250,
                             type       : "text",
                             align      : "left",
                             sortable   : true,
                             sortProp   : "text"  },
                date     : { label      : "Last Modified",
                             width      : 180,
                             type       : "text",
                             align      : "right",
                             sortable   : true   }
            };

            var lv = new qx.legacy.ui.listview.ListView(new Array, lc);

            lv.setWidth("100%");
            lv.setBorder("dark-shadow");
            lv.setHeight("2*");

            this.saveLoadConfigList = lv;
            rc.add(lv);

            btn_delete.addListener("execute", function(ev) {
                    var pane = lv.getPane();
                    var item = pane.getSelectedItem();
                    if (item && confirm("Delete \"" + item.name.text + "\"?")) {
                        this.removeConfig(item.name.text);
                        this.updateSaveLoadList();
                    }
                }, this);

            btn_rename.addListener("execute", function(ev) {
                    var pane = lv.getPane();
                    var item = pane.getSelectedItem();
                    if (item) {
                        var name = item.name.text;
                        var newname = prompt("Rename \"" + name + "\" to", name);
                        if (newname && newname != name) {
                            this.renameConfig(name, newname);
                            this.updateSaveLoadList();
                        }
                    }
                }, this);

            e = new pf.ui.TextField();
            e.setWidth("100%");
            rc.add(e);
            
            this.saveLoadTextField = e;

            var sm = lv.getPane().getManager();
            sm.setMultiSelection(false);
            sm.addListener("changeSelection", function(ev) {
                    var item = this.getSelectedItem();
                    if (!item) {
                        e.setValue(null);
                        btn_delete.setEnabled(false);
                        btn_rename.setEnabled(false);
                    } else {
                        e.setValue(item.name.text);
                        btn_rename.setEnabled(true);
                        btn_delete.setEnabled(true);
                    }
                });
            

            rc1 = new qx.legacy.ui.layout.HorizontalBoxLayout("horizontal");
            rc1.set({width                   : "100%",
                     height                  : "auto",
                     horizontalChildrenAlign : "right",
                     verticalChildrenAlign   : "bottom"});
            rc.add(rc1);

            btn = new qx.legacy.ui.form.Button("Cancel",
                "pf/image/cancel.png");
            btn.addListener("execute", function(ev) {
                    this.saveLoadWindow.close();
                }, this);
            rc1.add(btn);

            btn = new qx.legacy.ui.form.Button("OK",
                "pf/image/ok.png");
            btn.addListener("execute", function(ev) {
                    var cfgname = this.saveLoadTextField.getValue(); 
                    if (!cfgname) {
                        alert("Please enter a name!");
                    } else {
                        var type = w.getUserData("type");
                        if (type == "save") {
                            if (this.saveConfig(cfgname) == true) {
                                this.saveLoadWindow.close();
                            } else {
                                alert("Save failed!");
                            }
                        } else {
                            if (this.loadConfig(cfgname) == true) {
                                this.updatePlasmaParameters();
                                this.updateGUI();
                                this.saveLoadWindow.close();
                            } else {
                                alert("Load failed!");
                            }
                        }
                    }
                }, this);
            rc1.add(btn);

            e.setLiveUpdate(true);
            e.addListener("changeValue", function(ev) {
                    var name = this.getValue();
                    btn.setEnabled(null != name && name.length != 0);
                });
                
            this.doc.add(w);
            this.saveLoadWindow = w;
        },

        createPrefsDialog : function()
        {
            var w;
            // "Preferences..." dialog
            w = new qx.legacy.ui.window.Window("Preferences",
                "pf/image/preferences.png");
            w.setSpace(200, "auto", 100, "auto");
            w.setModal(true);
            w.setShowMinimize(false);
            w.setShowMaximize(false);

            var vbl = new qx.legacy.ui.layout.VerticalBoxLayout("vertical");
            vbl.setStretchChildrenOrthogonalAxis(false);
            w.add(vbl);
            
            var fr1, fr2, rc, l, e;
            
            fr1 = new qx.legacy.ui.groupbox.GroupBox("Default units");
            fr1.setDimension("auto", "auto");
            vbl.add(fr1);
            
            rc = new qx.legacy.ui.layout.HorizontalBoxLayout;
            rc.setWidth("100%");
            rc.setHeight("auto");
            rc.setSpacing(10);
            fr1.add(rc);

            l = new qx.legacy.ui.basic.Label("Dimension:");
            e = new pf.ui.ComboBox;
            e.add(new qx.legacy.ui.form.ListItem("Frequency", null, "frequency"));
            e.add(new qx.legacy.ui.form.ListItem("Length", null, "length"));
            e.add(new qx.legacy.ui.form.ListItem("Velocity", null, "velocity"));
            e.add(new qx.legacy.ui.form.ListItem("Energy", null, "energy"));
            e.add(new qx.legacy.ui.form.ListItem("Pressure", null, "pressure"));
            e.add(new qx.legacy.ui.form.ListItem("Area", null, "area"));
            e.add(new qx.legacy.ui.form.ListItem("Power density", null, "power_density"));
            e.add(new qx.legacy.ui.form.ListItem("Power spectral density",
                null, "spectral_power_density"));
            e.add(new qx.legacy.ui.form.ListItem("Electric field", null, "efield"));
            e.addListener("changeSelected", function(ev) {
                    var dimension = ev.getTarget().getSelectedValue();
                    this.gui_prefs_units.update(dimension,
                        this.prefs.units[dimension]);
                }, this);
            rc.add(l, e);
            this.gui_prefs_dim = e;

            l = new qx.legacy.ui.basic.Label("Units:");
            e = new pf.UnitSelector();
            e.addListener("changeSelected", function(ev) {
                    var dimension = this.gui_prefs_dim.getSelectedValue();
                    var units = ev.getTarget().getValue();
                    this.prefs.units[dimension] = units;
                }, this);
            rc.add(l, e);
            this.gui_prefs_units = e;

            fr2 = new qx.legacy.ui.groupbox.GroupBox("Interface");
            fr2.setDimension("auto", "auto");
            vbl.add(fr2);
            // A hack...
            fr1.addListener("appear", function(ev) {
                    fr2.setWidth(this.getWidthValue());
                });

            rc = new qx.legacy.ui.layout.VerticalBoxLayout;
            rc.setWidth("100%");
            rc.setHeight("auto");
            rc.setSpacing(10);
            fr2.add(rc);

            e = new qx.legacy.ui.form.CheckBox("Load Wikipedia articles automatically");
            e.setChecked(this.prefs.autoLoadWiki);
            e.addListener("changeChecked", function(ev) {
                this.prefs.autoLoadWiki = ev.getTarget().getChecked();
            }, this);
            rc.add(e);

            e = new qx.legacy.ui.form.CheckBox("Remember window dimensions on exit");
            e.setChecked(this.prefs.rememberWindowSize);
            e.addListener("changeChecked", function(ev) {
                this.prefs.rememberWindowSize = ev.getTarget().getChecked();
            }, this);
            rc.add(e);

            this.doc.add(w);
            this.prefsWindow = w;
        },

        /**
         * TODOC
         *
         * @type member
         * @param e {Event} TODOC
         * @return {void}
         */
        main : function(e)
        {
            this.base(arguments);
            this.compat();

            // Enable logging in debug variant
            if (qx.core.Variant.isSet("qx.debug", "on"))
            {
                // support native logging capabilities, e.g. Firebug
                qx.log.appender.Native;
                // support additional cross-browser console. (Press F7)
                qx.log.appender.Console;
            }
            
            this.doc = qx.legacy.ui.core.ClientDocument.getInstance();
            this.win = this.doc.getWindowElement();
            
            // Load prefs
            this.loadPreferences();
            
            // Defaults
            this.r = new pf.base.Species("r", 1.0,           0, 0,    1.0, null);
            this.e = new pf.base.Species("e", (1.0/1836.2), -1, 1e16, 1.0, this.r);
            this.i = new pf.base.Species("i", 1.0,          +1, 1e16, 1.0, this.r);
            
            this.P_r = 0;

            this.B   = 0;
            
            this.n_u = 2;
            this.n_l = 1;

            // Load config from the previous session
            if (this.prefs.currentConfigName) {
                this.loadConfig(this.prefs.currentConfigName);
            }
            
            if (this.updatePlasmaParameters() != true) {
                this.error("Error updating plasma parameters!");
            }
            
            // Favorites
            this.favorites = new Array;
            
            this.colorMap = new Array("red", "blue", "green", "orange",
                "brown", "olive", "teal", "magenta", "grey", "black");
            this.ncolor = 0;

            // Top-level container
            this.bl_top = new qx.legacy.ui.layout.VerticalBoxLayout("vertical");
            this.bl_top.setWidth("100%");
            this.bl_top.setHeight("100%");

            this.bl_top.addToDocument();

            // The menubar
            this.menubar = new qx.legacy.ui.menubar.MenuBar;
            this.bl_top.add(this.menubar);
            
            // The menu items
            this.buildMenu();
            
            var tf1 = new qx.legacy.ui.pageview.tabview.TabView;
            tf1.set({ width : '100%', height : '2*' });

            this.bl_top.add(tf1);

            this.tabbar  = tf1.getBar();
            this.tabpane = tf1.getPane();
            this.tabpane.setHeight('3*');
            this.tabpane.setPadding(0, 0, 0, 0);

            // The "Parameters" tab
            this.renderParametersTab();
            
            // The "Explorer" tab
            this.renderExplorerTab();
            
            // The "Compare" tab
            this.renderCompareTab();
            
            // The "Plot" tab
            this.renderPlotTab();
            
            // "Preferences" dialog
            this.createPrefsDialog();

            // "Save as" dialog
            this.createSaveLoadDialog();

            // "About..." dialog
            w = new qx.legacy.ui.window.Window("About Plasma Formulary",
                "pf/image/about.png");
            w.setSpace(200, "auto", 100, "auto");
            w.setModal(true);
            w.setShowMinimize(false);
            w.setShowMaximize(false);
            
            var version = qx.core.Version;
            if (!version) {
                version = '0.8.1';
            }
            str = 'Plasma Formulary Interactive.<br/>'    +
                  '$Revision$.'                    +
                  '<p>Written by Evgeny Stambulchik.</p>' +
                  '<p>GUI built with the Qooxdoo-'        + 
                  version + ' toolkit.<br/>'              + 
                  'Using Walter Zorn jsGraphics for drawing.</p>';

            var a = new qx.legacy.ui.basic.Atom(str);
            a.set({ top: 4, left: 4 });
            w.add(a);

            this.doc.add(w);
            this.aboutWindow = w;
            
            if (this.prefs.rememberWindowSize && this.prefs.dims) {
                self.resizeTo(this.prefs.dims.w,this.prefs.dims.h)
            }

            // Handle resize events
            this.doc.addListener("windowresize", function(e) {
                if (this.prefs.rememberWindowSize) {
                    this.prefs.dims = this.getWindowDimensions();
                }
                this.drawAll();
            }, this);
        },
    

        /**
         * TODOC
         *
         * @type member
         * @param e {Event} TODOC
         * @return {void}
         */
        close : function(e)
        {
            // Save preferences
            this.savePreferences();

            this.base(arguments);
            this.compat();
            
            // Prompt user
            // return "Do you really want to close the application?";
        }
    }
});
